// material-ui
import {
    DataGrid,
} from "@mui/x-data-grid";
import {useEffect, useState} from "react";
import axios from "axios";
import {apiPath} from "../../auth/utils";
import LoadingComponent from "../extra-pages/LoadingComponent";
import * as React from "react";
import {GET_GROUP_AUTH_LIST} from "../../utils/ApiPathConst";
import {CustomNoRowsOverlay} from "../../utils/CommonFunction";

// ==============================|| EVENT TABLE ||============================== //

export default function GroupAuthTable({setSelectedRow, userAuth}) {
    const [authData, setAuthData] = useState([]);
    const [onReady, setOnReady] = useState(false);
    const [currentSelectedRow, setCurrentSelectedRow] = useState(userAuth);

    useEffect(() => {
        axios.get(`${apiPath}${GET_GROUP_AUTH_LIST}`)
            .then((response) => {
                if (response.status === 200) {
                    setAuthData(response.data.records);
                }
            })
            .catch(error => {
                console.log(error);
                return false;
            });
    }, []);

    useEffect(() => {
        //if state data are ready and assign to different field
        if (authData.length > 0) {
            setOnReady(true);
        }
    }, [authData]);

    const columns = [
        {
            id: 'module',
            field: 'module',
            headerName: 'Module',
            flex: 1,
        },
        {
            id: 'authority',
            field: 'name',
            headerName: 'Authority',
            flex: 2,
        },
    ];

    return (
        !onReady ?
            <LoadingComponent/>
            :
            <div style={{height: '74vh', width: '100%'}}>
                <DataGrid
                    rows={authData}
                    columns={columns}
                    columnHeaderHeight={45}
                    editMode="row"
                    initialState={{
                        pagination: {
                            paginationModel: {page: 0, pageSize: 14},
                        },
                    }}
                    slots={{
                        noRowsOverlay: () => (
                            CustomNoRowsOverlay()
                        )
                    }}
                    getRowHeight={() => 'auto'}
                    pageSizeOptions={[14]}
                    checkboxSelection
                    rowSelectionModel={currentSelectedRow}
                    onRowSelectionModelChange={(ids) => {
                        setSelectedRow(ids);
                        setCurrentSelectedRow(ids);
                    }}
                />
            </div>
    );
}
